//***********************************************
// @@@ USB ֘A萔̐錾                    *
//***********************************************
//USB1.0ظ
#define    GET_STATUS           0
#define    CLEAR_FEATURE        1
#define    SET_FEATURE          3
#define    SET_ADDRESS          5
#define    GET_DESCRIPTOR       6
#define    SET_DESCRIPTOR       7
#define    GET_CONFIGURATION    8
#define    SET_CONFIGURATION    9
#define    GET_INTERFACE        10
#define    SET_INTERFACE        11
#define    SYNCH_FRAME          12
#define    REQ_DONE             0xFF    //private code: request done

//޽
#define    DEVICE               1
#define    CONFIGURATION        2
#define    XSTRING              3
#define    INTERFACE            4
#define    ENDPOINT             5

#define    DEVICE_REMOTE_WAKEUP 1
#define    ENDPOINT_STALL       0
#define    HID                  0x21
#define    HIDREPORT            0x22
#define    HIDPHYSICAL          0x23


//׽
#define    HIDCLASS             3
#define    NOSUBCLASS           0
#define    BOOTSUBCLASS         1
#define    VENDORSPEC           0xFF

//HID ظĂɊւ萔
#define    GET_REPORT           1
#define    GET_IDLE             2
#define    GET_PROTOCOL         3
#define    SET_REPORT           9
#define    SET_IDLE             0xA
#define    SET_PROTOCOL         0xB

  
//e޽̒
#define     DEV_LENGTH      18
#define     CFG_LENGTH      9
#define     INT_LENGTH      9
#define     HID_LENGTH      9 //HIDgꍇ9޲Ďw
#define     END_LENGTH      7

///// Descriptor Offset
#define     DEV_DESC_OFS    0
#define     CFG_DESC_OFS    DEV_LENGTH
#define     IF_DESC_OFS     CFG_DESC_OFS + CFG_LENGTH
#define     HID_DESC_OFS    IF_DESC_OFS + INT_LENGTH
#define     EOP_DESC_OFS    HID_DESC_OFS + HID_LENGTH
#define     HIDREPORT_OFS   EOP_DESC_OFS + (END_LENGTH * 1)


#pragma section C1
/************************************************************/
/*  Data table                                              */
/************************************************************/
/*SINGLE HID INTERFACE*/

#define	DEV_DESC_SIZE       DEV_LENGTH
#define	CFG_DESC_SIZE	CFG_LENGTH + INT_LENGTH + 2 * END_LENGTH
#define	IF_DESC_SIZE       INT_LENGTH
#define	EOP_DESC_SIZE       END_LENGTH

const unsigned char DEV_DESC[] = {DEV_LENGTH,        /*length of this descriptor    */
                         DEVICE,            /*DEVICE descriptor       */
                         0x00,0x01,         /*spec rev level (BCD)    */
                         0x00,              /*device class            */
                         0x00,              /*device subclass         */
                         0x00,              /*device protocol         */
                         0x08,              /*max packet size         */
                         0xda,0x8,         /*AW's vendor ID    */
                         0x20,0xfe,         /*AW's product ID   */
                         0x01,0x00,         /*AW's revision ID  */
                         1,       /*index of manuf. string  1*/
                         2,       /*index of prod.  string  2*/
                         0,                 /*index of ser. # string  */
                         0x01               /*number of configs.      */
                         };

#ifdef  BUSPOWER
#define ATTRIBUTES 0x80                     /*bus  powered            */
#else
#define ATTRIBUTES 0x40                     /*self powered            */
#endif

const unsigned char CFG_DESC[] = {CFG_LENGTH,        /*length of this descriptor    */
						CONFIGURATION,     /*CONFIGURATION descriptor*/
						CFG_DESC_SIZE,  //	;total length returned Hi
						0,              // total length returned Lo
                         0x01,              /*number of interfaces    */
                         0x01,              /*number of this config   */
                         4,       /*index of config. string */
                         ATTRIBUTES,        /*attr.: bus  powered     */
                         50,                /*max power (100 mA)      */
//IF_DESC
                         INT_LENGTH,        /*length of this descriptor    */
                         INTERFACE,         /*INTERFACE descriptor    */
                         0x00,              /*interface number        */
                         0x00,              /*alternate setting       */
                         0x02,              /*# of (non 0) endpoints  */
                         0,          /*interface class         */
                         0,        /*interface subclass      */
                         0,              /*interface protocol      */
                         5,       /*index of intf. string   */

/*The WDM driver for this board references the endpoints by 'pipe'    */
/*number: 0, 1, 2 et al in order below:                               */

                       /*Pipe 0 (endpoint 1)                          */
                         END_LENGTH,        /*length of this desc.    */
                         ENDPOINT,          /*ENDPOINT descriptor     */
                         0x01,              /*address (OUT)            */
                         0x02,              /*attributes  (BULK) */
                         0x40,0x00,         /*max packet size (32)    */
                         0xff,             /*interval (ms)           */

                       /*Pipe 1 (endpoint 2)                          */
                         END_LENGTH,        /*length of this desc.    */
                         ENDPOINT,          /*ENDPOINT descriptor     */
                         0x82,              /*address (IN)            */
                         0x02,              /*attributes  (BULK) */
                         0x40,0x00,         /*max packet size (32)    */
                         0xff,             /*interval (ms)           */

};


#define     SIZE            DEV_LENGTH + CFG_LENGTH + INT_LENGTH + 2*END_LENGTH 

///////// String Data Offset //////////////
#define     STR_OFS     SIZE
#define         LANG_SIZE       4
#define     MFG_STR_OFS SIZE+4
#define         MFG_SIZE        8
#define     PID_STR_OFS SIZE+12
#define         PID_SIZE        20
#define     NBR_STR_OFS SIZE+32
#define         NBR_SIZE        6
#define     CFG_STR_OFS SIZE+38
#define         CFG_SIZE        26
#define     INT_STR_OFS SIZE+64
#define         INT_SIZE        20
#define     END_STR_OFS SIZE+84


	
//;**************    Strings Data    ******************
const unsigned char STR_DATA[] = {4,3,9,4};             /*LANGID array (English) */
const unsigned char MFG_STR[] = {			// ;"MFG"
	8, 3,
	'M', 0, 'F', 0, 'G', 0};
const unsigned char PID_STR[] = {			//;"H8SX Demo"
	28, 3,
	'H', 0, '8', 0, 'S', 0, 'X', 0,
	' ', 0, 'D', 0, 'e', 0, 'm', 0,	'o', 0
	};
const unsigned char NBR_STR[] =	{	//;"??"
	6, 3,
	'?', 0, '?', 0};

const unsigned char CFG_STR[] = {                // "Std. Config."
	26, 3,
	'S', 0, 't', 0, 'd', 0, '.', 0, ' ', 0, 'C', 0, 'o', 0, 'n', 0,
	'f', 0, 'i', 0, 'g', 0, '.', 0};

const unsigned char INT_STR[] = {                // "Interface"
	20, 3,
	'I', 0, 'n', 0, 't', 0, 'e', 0, 'r', 0, 'f', 0,
	'a', 0, 'c', 0, 'e', 0};

const unsigned char endp_data[50] = {
	0x00, 0x00, 0x10, 0x00, 0x00,
	0x14, 0x20, 0x80, 0x00, 0x01,
	0x24, 0x28, 0x80, 0x00, 0x02,
	0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00,
};

